
def supported_version():
    return ['postgresql_10', 'postgresql_8.1', 'sql_2003', 'sql_1999', 'sql_92']


def reserved(word, version="postgresql_10"):
    """
    list of sql words pulled from http://www.postgresql.org/docs/8.1/sql-keywords-appendix.html

    from pandas import read_html
    df_sql = read_html("http://www.postgresql.org/docs/8.1/sql-keywords-appendix.html")[1]
    df_sql[df_sql["SQL-92"]=='reserved']['Key Word'].values

    """
    if version == 'postgresql_10':
        reserved_words = ['ALL', 'ANALYSE', 'ANALYZE', 'AND', 'ANY', 'ARRAY', 'AS', 'ASC',
                          'ASYMMETRIC', 'AUTHORIZATION', 'BETWEEN', 'BINARY', 'BOTH', 'CASE',
                          'CAST', 'CHECK', 'COLLATE', 'COLUMN', 'CONSTRAINT', 'CREATE',
                          'CROSS', 'CURRENT_DATE', 'CURRENT_ROLE', 'CURRENT_TIME',
                          'CURRENT_TIMESTAMP', 'CURRENT_USER', 'DEFAULT', 'DEFERRABLE',
                          'DESC', 'DISTINCT', 'DO', 'ELSE', 'END', 'EXCEPT', 'FALSE', 'FOR',
                          'FOREIGN', 'FREEZE', 'FROM', 'FULL', 'GRANT', 'GROUP', 'HAVING',
                          'ILIKE', 'IN', 'INITIALLY', 'INNER', 'INTERSECT', 'INTO', 'IS',
                          'ISNULL', 'JOIN', 'LEADING', 'LEFT', 'LIKE', 'LIMIT', 'LOCALTIME',
                          'LOCALTIMESTAMP', 'NATURAL', 'NEW', 'NOT', 'NOTNULL', "nan", 'OFF',
                          'OFFSET', 'OLD', 'ON', 'ONLY', 'OR', 'ORDER', 'OUTER', 'OVERLAPS',
                          'PLACING', 'PRIMARY', 'REFERENCES', 'RIGHT', 'SELECT',
                          'SESSION_USER', 'SIMILAR', 'SOME', 'SYMMETRIC', 'TABLE', 'THEN',
                          'TO', 'TRAILING', 'TRUE', 'UNION', 'UNIQUE', 'USER', 'USING',
                          'VERBOSE', 'WHEN', 'WHERE']

    elif version == 'postgresql_8.1':
        reserved_words = ['ALL', 'ANALYSE', 'ANALYZE', 'AND', 'ANY', 'ARRAY', 'AS', 'ASC',
                          'ASYMMETRIC', 'AUTHORIZATION', 'BETWEEN', 'BINARY', 'BOTH', 'CASE',
                          'CAST', 'CHECK', 'COLLATE', 'COLUMN', 'CONSTRAINT', 'CREATE',
                          'CROSS', 'CURRENT_DATE', 'CURRENT_ROLE', 'CURRENT_TIME',
                          'CURRENT_TIMESTAMP', 'CURRENT_USER', 'DEFAULT', 'DEFERRABLE',
                          'DESC', 'DISTINCT', 'DO', 'ELSE', 'END', 'EXCEPT', 'FALSE', 'FOR',
                          'FOREIGN', 'FREEZE', 'FROM', 'FULL', 'GRANT', 'GROUP', 'HAVING',
                          'ILIKE', 'IN', 'INITIALLY', 'INNER', 'INTERSECT', 'INTO', 'IS',
                          'ISNULL', 'JOIN', 'LEADING', 'LEFT', 'LIKE', 'LIMIT', 'LOCALTIME',
                          'LOCALTIMESTAMP', 'NATURAL', 'NEW', 'NOT', 'NOTNULL', nan, 'OFF',
                          'OFFSET', 'OLD', 'ON', 'ONLY', 'OR', 'ORDER', 'OUTER', 'OVERLAPS',
                          'PLACING', 'PRIMARY', 'REFERENCES', 'RIGHT', 'SELECT',
                          'SESSION_USER', 'SIMILAR', 'SOME', 'SYMMETRIC', 'TABLE', 'THEN',
                          'TO', 'TRAILING', 'TRUE', 'UNION', 'UNIQUE', 'USER', 'USING',
                          'VERBOSE', 'WHEN', 'WHERE']

    elif version == "sql_2003":
        reserved_words = ['ABS', 'ALL', 'ALLOCATE', 'ALTER', 'AND', 'ANY', 'ARE', 'ARRAY',
                          'AS', 'ASENSITIVE', 'ASYMMETRIC', 'AT', 'ATOMIC', 'AUTHORIZATION',
                          'AVG', 'BEGIN', 'BETWEEN', 'BIGINT', 'BINARY', 'BLOB', 'BOOLEAN',
                          'BOTH', 'BY', 'CALL', 'CALLED', 'CARDINALITY', 'CASCADED', 'CASE',
                          'CAST', 'CEIL', 'CEILING', 'CHAR', 'CHARACTER', 'CHARACTER_LENGTH',
                          'CHAR_LENGTH', 'CHECK', 'CLOB', 'CLOSE', 'COALESCE', 'COLLATE',
                          'COLLECT', 'COLUMN', 'COMMIT', 'CONDITION', 'CONNECT',
                          'CONSTRAINT', 'CONVERT', 'CORR', 'CORRESPONDING', 'COUNT',
                          'COVAR_POP', 'COVAR_SAMP', 'CREATE', 'CROSS', 'CUBE', 'CUME_DIST',
                          'CURRENT', 'CURRENT_DATE', 'CURRENT_DEFAULT_TRANSFORM_GROUP',
                          'CURRENT_PATH', 'CURRENT_ROLE', 'CURRENT_TIME',
                          'CURRENT_TIMESTAMP', 'CURRENT_TRANSFORM_GROUP_FOR_TYPE',
                          'CURRENT_USER', 'CURSOR', 'CYCLE', 'DATE', 'DAY', 'DEALLOCATE',
                          'DEC', 'DECIMAL', 'DECLARE', 'DEFAULT', 'DELETE', 'DENSE_RANK',
                          'DEREF', 'DESCRIBE', 'DETERMINISTIC', 'DISCONNECT', 'DISTINCT',
                          'DOUBLE', 'DROP', 'DYNAMIC', 'EACH', 'ELEMENT', 'ELSE', 'END',
                          'END-EXEC', 'ESCAPE', 'EVERY', 'EXCEPT', 'EXEC', 'EXECUTE',
                          'EXISTS', 'EXP', 'EXTERNAL', 'EXTRACT', 'FALSE', 'FETCH', 'FILTER',
                          'FLOAT', 'FLOOR', 'FOR', 'FOREIGN', 'FREE', 'FROM', 'FULL',
                          'FUNCTION', 'FUSION', 'GET', 'GLOBAL', 'GRANT', 'GROUP',
                          'GROUPING', 'HAVING', 'HOLD', 'HOUR', 'IDENTITY', 'IN',
                          'INDICATOR', 'INNER', 'INOUT', 'INSENSITIVE', 'INSERT', 'INT',
                          'INTEGER', 'INTERSECT', 'INTERSECTION', 'INTERVAL', 'INTO', 'IS',
                          'JOIN', 'LANGUAGE', 'LARGE', 'LATERAL', 'LEADING', 'LEFT', 'LIKE',
                          'LN', 'LOCAL', 'LOCALTIME', 'LOCALTIMESTAMP', 'LOWER', 'MATCH',
                          'MAX', 'MEMBER', 'MERGE', 'METHOD', 'MIN', 'MINUTE', 'MOD',
                          'MODIFIES', 'MODULE', 'MONTH', 'MULTISET', 'NATIONAL', 'NATURAL',
                          'NCHAR', 'NCLOB', 'NEW', 'NO', 'NONE', 'NORMALIZE', 'NOT', nan,
                          'NULLIF', 'NUMERIC', 'OCTET_LENGTH', 'OF', 'OLD', 'ON', 'ONLY',
                          'OPEN', 'OR', 'ORDER', 'OUT', 'OUTER', 'OVER', 'OVERLAPS',
                          'OVERLAY', 'PARAMETER', 'PARTITION', 'PERCENTILE_CONT',
                          'PERCENTILE_DISC', 'PERCENT_RANK', 'POSITION', 'POWER',
                          'PRECISION', 'PREPARE', 'PRIMARY', 'PROCEDURE', 'RANGE', 'RANK',
                          'READS', 'REAL', 'RECURSIVE', 'REF', 'REFERENCES', 'REFERENCING',
                          'REGR_AVGX', 'REGR_AVGY', 'REGR_COUNT', 'REGR_INTERCEPT',
                          'REGR_R2', 'REGR_SLOPE', 'REGR_SXX', 'REGR_SXY', 'REGR_SYY',
                          'RELEASE', 'RESULT', 'RETURN', 'RETURNS', 'REVOKE', 'RIGHT',
                          'ROLLBACK', 'ROLLUP', 'ROW', 'ROWS', 'ROW_NUMBER', 'SAVEPOINT',
                          'SCOPE', 'SCROLL', 'SEARCH', 'SECOND', 'SELECT', 'SENSITIVE',
                          'SESSION_USER', 'SET', 'SIMILAR', 'SMALLINT', 'SOME', 'SPECIFIC',
                          'SPECIFICTYPE', 'SQL', 'SQLEXCEPTION', 'SQLSTATE', 'SQLWARNING',
                          'SQRT', 'START', 'STATIC', 'STDDEV_POP', 'STDDEV_SAMP',
                          'SUBMULTISET', 'SUBSTRING', 'SUM', 'SYMMETRIC', 'SYSTEM',
                          'SYSTEM_USER', 'TABLE', 'TABLESAMPLE', 'THEN', 'TIME', 'TIMESTAMP',
                          'TIMEZONE_HOUR', 'TIMEZONE_MINUTE', 'TO', 'TRAILING', 'TRANSLATE',
                          'TRANSLATION', 'TREAT', 'TRIGGER', 'TRIM', 'TRUE', 'UESCAPE',
                          'UNION', 'UNIQUE', 'UNKNOWN', 'UNNEST', 'UPDATE', 'UPPER', 'USER',
                          'USING', 'VALUE', 'VALUES', 'VARCHAR', 'VARYING', 'VAR_POP',
                          'VAR_SAMP', 'WHEN', 'WHENEVER', 'WHERE', 'WIDTH_BUCKET', 'WINDOW',
                          'WITH', 'WITHIN', 'WITHOUT']

    elif version == "sql_1999":
        reserved_words = ['ABSOLUTE', 'ACTION', 'ADD', 'ADMIN', 'AFTER', 'AGGREGATE',
                          'ALIAS', 'ALL', 'ALLOCATE', 'ALTER', 'AND', 'ANY', 'ARE', 'ARRAY',
                          'AS', 'ASC', 'ASSERTION', 'AT', 'AUTHORIZATION', 'BEFORE', 'BEGIN',
                          'BINARY', 'BIT', 'BLOB', 'BOOLEAN', 'BOTH', 'BREADTH', 'BY',
                          'CALL', 'CASCADE', 'CASCADED', 'CASE', 'CAST', 'CATALOG', 'CHAR',
                          'CHARACTER', 'CHECK', 'CLASS', 'CLOB', 'CLOSE', 'COLLATE',
                          'COLLATION', 'COLUMN', 'COMMIT', 'COMPLETION', 'CONNECT',
                          'CONNECTION', 'CONSTRAINT', 'CONSTRAINTS', 'CONSTRUCTOR',
                          'CONTINUE', 'CORRESPONDING', 'CREATE', 'CROSS', 'CUBE', 'CURRENT',
                          'CURRENT_DATE', 'CURRENT_PATH', 'CURRENT_ROLE', 'CURRENT_TIME',
                          'CURRENT_TIMESTAMP', 'CURRENT_USER', 'CURSOR', 'CYCLE', 'DATA',
                          'DATE', 'DAY', 'DEALLOCATE', 'DEC', 'DECIMAL', 'DECLARE',
                          'DEFAULT', 'DEFERRABLE', 'DEFERRED', 'DELETE', 'DEPTH', 'DEREF',
                          'DESC', 'DESCRIBE', 'DESCRIPTOR', 'DESTROY', 'DESTRUCTOR',
                          'DETERMINISTIC', 'DIAGNOSTICS', 'DICTIONARY', 'DISCONNECT',
                          'DISTINCT', 'DOMAIN', 'DOUBLE', 'DROP', 'DYNAMIC', 'EACH', 'ELSE',
                          'END', 'END-EXEC', 'EQUALS', 'ESCAPE', 'EVERY', 'EXCEPT',
                          'EXCEPTION', 'EXEC', 'EXECUTE', 'EXTERNAL', 'FALSE', 'FETCH',
                          'FIRST', 'FLOAT', 'FOR', 'FOREIGN', 'FOUND', 'FREE', 'FROM',
                          'FULL', 'FUNCTION', 'GENERAL', 'GET', 'GLOBAL', 'GO', 'GOTO',
                          'GRANT', 'GROUP', 'GROUPING', 'HAVING', 'HOST', 'HOUR', 'IDENTITY',
                          'IGNORE', 'IMMEDIATE', 'IN', 'INDICATOR', 'INITIALIZE',
                          'INITIALLY', 'INNER', 'INOUT', 'INPUT', 'INSERT', 'INT', 'INTEGER',
                          'INTERSECT', 'INTERVAL', 'INTO', 'IS', 'ISOLATION', 'ITERATE',
                          'JOIN', 'KEY', 'LANGUAGE', 'LARGE', 'LAST', 'LATERAL', 'LEADING',
                          'LEFT', 'LESS', 'LEVEL', 'LIKE', 'LIMIT', 'LOCAL', 'LOCALTIME',
                          'LOCALTIMESTAMP', 'LOCATOR', 'MAP', 'MATCH', 'MINUTE', 'MODIFIES',
                          'MODIFY', 'MODULE', 'MONTH', 'NAMES', 'NATIONAL', 'NATURAL',
                          'NCHAR', 'NCLOB', 'NEW', 'NEXT', 'NO', 'NONE', 'NOT', nan,
                          'NUMERIC', 'OBJECT', 'OF', 'OFF', 'OLD', 'ON', 'ONLY', 'OPEN',
                          'OPERATION', 'OPTION', 'OR', 'ORDER', 'ORDINALITY', 'OUT', 'OUTER',
                          'OUTPUT', 'PAD', 'PARAMETER', 'PARAMETERS', 'PARTIAL', 'PATH',
                          'POSTFIX', 'PRECISION', 'PREFIX', 'PREORDER', 'PREPARE',
                          'PRESERVE', 'PRIMARY', 'PRIOR', 'PRIVILEGES', 'PROCEDURE',
                          'PUBLIC', 'READ', 'READS', 'REAL', 'RECURSIVE', 'REF',
                          'REFERENCES', 'REFERENCING', 'RELATIVE', 'RESTRICT', 'RESULT',
                          'RETURN', 'RETURNS', 'REVOKE', 'RIGHT', 'ROLE', 'ROLLBACK',
                          'ROLLUP', 'ROUTINE', 'ROW', 'ROWS', 'SAVEPOINT', 'SCHEMA', 'SCOPE',
                          'SCROLL', 'SEARCH', 'SECOND', 'SECTION', 'SELECT', 'SEQUENCE',
                          'SESSION', 'SESSION_USER', 'SET', 'SETS', 'SIZE', 'SMALLINT',
                          'SOME', 'SPACE', 'SPECIFIC', 'SPECIFICTYPE', 'SQL', 'SQLEXCEPTION',
                          'SQLSTATE', 'SQLWARNING', 'START', 'STATE', 'STATEMENT', 'STATIC',
                          'STRUCTURE', 'SYSTEM_USER', 'TABLE', 'TEMPORARY', 'TERMINATE',
                          'THAN', 'THEN', 'TIME', 'TIMESTAMP', 'TIMEZONE_HOUR',
                          'TIMEZONE_MINUTE', 'TO', 'TRAILING', 'TRANSACTION', 'TRANSLATION',
                          'TREAT', 'TRIGGER', 'TRUE', 'UNDER', 'UNION', 'UNIQUE', 'UNKNOWN',
                          'UNNEST', 'UPDATE', 'USAGE', 'USER', 'USING', 'VALUE', 'VALUES',
                          'VARCHAR', 'VARIABLE', 'VARYING', 'VIEW', 'WHEN', 'WHENEVER',
                          'WHERE', 'WITH', 'WITHOUT', 'WORK', 'WRITE', 'YEAR', 'ZONE']

    elif version == 'sql_92':
        reserved_words = ['ABSOLUTE', 'ACTION', 'ADD', 'ALL', 'ALLOCATE', 'ALTER', 'AND',
                          'ANY', 'ARE', 'AS', 'ASC', 'ASSERTION', 'AT', 'AUTHORIZATION',
                          'AVG', 'BEGIN', 'BETWEEN', 'BIT', 'BIT_LENGTH', 'BOTH', 'BY',
                          'CASCADE', 'CASCADED', 'CASE', 'CAST', 'CATALOG', 'CHAR',
                          'CHARACTER', 'CHARACTER_LENGTH', 'CHAR_LENGTH', 'CHECK', 'CLOSE',
                          'COALESCE', 'COLLATE', 'COLLATION', 'COLUMN', 'COMMIT', 'CONNECT',
                          'CONNECTION', 'CONSTRAINT', 'CONSTRAINTS', 'CONTINUE', 'CONVERT',
                          'CORRESPONDING', 'COUNT', 'CREATE', 'CROSS', 'CURRENT',
                          'CURRENT_DATE', 'CURRENT_TIME', 'CURRENT_TIMESTAMP',
                          'CURRENT_USER', 'CURSOR', 'DATE', 'DAY', 'DEALLOCATE', 'DEC',
                          'DECIMAL', 'DECLARE', 'DEFAULT', 'DEFERRABLE', 'DEFERRED',
                          'DELETE', 'DESC', 'DESCRIBE', 'DESCRIPTOR', 'DIAGNOSTICS',
                          'DISCONNECT', 'DISTINCT', 'DOMAIN', 'DOUBLE', 'DROP', 'ELSE',
                          'END', 'END-EXEC', 'ESCAPE', 'EXCEPT', 'EXCEPTION', 'EXEC',
                          'EXECUTE', 'EXISTS', 'EXTERNAL', 'EXTRACT', 'FALSE', 'FETCH',
                          'FIRST', 'FLOAT', 'FOR', 'FOREIGN', 'FOUND', 'FROM', 'FULL', 'GET',
                          'GLOBAL', 'GO', 'GOTO', 'GRANT', 'GROUP', 'HAVING', 'HOUR',
                          'IDENTITY', 'IMMEDIATE', 'IN', 'INDICATOR', 'INITIALLY', 'INNER',
                          'INPUT', 'INSENSITIVE', 'INSERT', 'INT', 'INTEGER', 'INTERSECT',
                          'INTERVAL', 'INTO', 'IS', 'ISOLATION', 'JOIN', 'KEY', 'LANGUAGE',
                          'LAST', 'LEADING', 'LEFT', 'LEVEL', 'LIKE', 'LOCAL', 'LOWER',
                          'MATCH', 'MAX', 'MIN', 'MINUTE', 'MODULE', 'MONTH', 'NAMES',
                          'NATIONAL', 'NATURAL', 'NCHAR', 'NEXT', 'NO', 'NOT', nan, 'NULLIF',
                          'NUMERIC', 'OCTET_LENGTH', 'OF', 'ON', 'ONLY', 'OPEN', 'OPTION',
                          'OR', 'ORDER', 'OUTER', 'OUTPUT', 'OVERLAPS', 'PAD', 'PARTIAL',
                          'POSITION', 'PRECISION', 'PREPARE', 'PRESERVE', 'PRIMARY', 'PRIOR',
                          'PRIVILEGES', 'PROCEDURE', 'PUBLIC', 'READ', 'REAL', 'REFERENCES',
                          'RELATIVE', 'RESTRICT', 'REVOKE', 'RIGHT', 'ROLLBACK', 'ROWS',
                          'SCHEMA', 'SCROLL', 'SECOND', 'SECTION', 'SELECT', 'SESSION',
                          'SESSION_USER', 'SET', 'SIZE', 'SMALLINT', 'SOME', 'SPACE', 'SQL',
                          'SQLCODE', 'SQLERROR', 'SQLSTATE', 'SUBSTRING', 'SUM',
                          'SYSTEM_USER', 'TABLE', 'TEMPORARY', 'THEN', 'TIME', 'TIMESTAMP',
                          'TIMEZONE_HOUR', 'TIMEZONE_MINUTE', 'TO', 'TRAILING',
                          'TRANSACTION', 'TRANSLATE', 'TRANSLATION', 'TRIM', 'TRUE', 'UNION',
                          'UNIQUE', 'UNKNOWN', 'UPDATE', 'UPPER', 'USAGE', 'USER', 'USING',
                          'VALUE', 'VALUES', 'VARCHAR', 'VARYING', 'VIEW', 'WHEN',
                          'WHENEVER', 'WHERE', 'WITH', 'WORK', 'WRITE', 'YEAR', 'ZONE']

    else:
        raise Exception("specified version {} was not found".format(version))

    if word.upper() in reserved_words:
        return True

    return False
